package org.springblade.flow.engine.service;

import java.util.List;

import org.springblade.flow.base.Pagination;
import org.springblade.flow.engine.dto.AvailableFlowDelegateDTO;
import org.springblade.flow.engine.entity.FlowDelegateEntity;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 流程委托
 *
 * @author JNPF开发平台组
 * @version V3.1.0
 * @copyright 引迈信息技术有限公司
 * @date 2019年9月27日 上午9:18
 */
public interface FlowDelegateService extends IService<FlowDelegateEntity> {

    List<String> batchGetAvailableProcessData(List<AvailableFlowDelegateDTO> availableFlowDelegateDTOList);
    String getAvailableProcessData(AvailableFlowDelegateDTO availableFlowDelegateDTO);


    /**
     * 列表
     *
     * @param pagination 请求参数
     * @return
     */
    List<FlowDelegateEntity> getList(Pagination pagination);

    /**
     * 列表
     *
     * @return
     */
    List<FlowDelegateEntity> getList();



    /**
     * 信息
     *
     * @param id 主键值
     * @return
     */
    FlowDelegateEntity getInfo(String id);

    /**
     * 删除
     *
     * @param entity 实体对象
     */
    void delete(FlowDelegateEntity entity);

    /**
     * 创建
     *
     * @param entity 实体对象
     */
    void create(FlowDelegateEntity entity);

    /**
     * 获取委托的表单
     *
     * @param userId 主键值
     * @return
     */
    List<FlowDelegateEntity> getUser(String userId);

    /**
     * 更新
     *
     * @param id     主键值
     * @param entity 实体对象
     * @return
     */
    boolean update(String id, FlowDelegateEntity entity);

}
